/*
This NanoJ Example Code is based on our experience with typical user requirements in a wide range
of industrial applications and is provided without guarantee regarding correctness and completeness.
It serves as general guidance and should not be construed as a commitment of Nanotec to guarantee its
applicability to the customer application without additional tests under the specific conditions
and  if and when necessary  modifications by the customer. 

The responsibility for the applicability and use of the NanoJ Example Code in a particular
customer application lies solely within the authority of the customer.
It is the customer's responsibility to evaluate, investigate and decide,
whether the Example Code is valid and suitable for the respective customer application, or not.
Defects resulting from the improper handling of devices and modules are excluded from the warranty.
Under no circumstances will Nanotec be liable for any direct, indirect, incidental or consequential damages
arising in connection with the Example Code provided. In addition, the regulations regarding the
liability from our Terms and Conditions of Sale and Delivery shall apply.
*/

//in diesem Beispiel wird der Drehzahl-Modus gewhlt und die state machine eingeschaltet

//1. Schritt: mappen von hufig verwenden SDOs

map U16 ControlWord as output 0x6040:00
map S08 OperationMode as output 0x6060:00
map S16 TargetVelocity as output 0x6042:00

#include "wrapper.h"


//2. Schritt: Hauptfunktion aufrufen und gewnschte Einstellungen treffen

void user()
{
	
	//sleep(5000);                      // warte 5000 Millisekunden (optional wenn gewnscht)
	Out.OperationMode = 2;				// setzt den Operationsmodus auf Drehzahlmodus (mit Mapping, Zeile 5-7)
	//od_write(0x6060,0x00, 2);			// setzt ebenfalls den Operationsmodus (ohne Mapping, Zeile 5-7)
		
	Out.TargetVelocity = 200;			// setzt die Zielgeschwindigkeit auf 200 U/min (Standardeinheit)(mit Mapping, Zeile 5-7)
	//od_write(0x6042,0x00, 200);		// setzt die Zielgeschwindigkeit auf 200 U/min (Standardeinheit)(ohne Mapping, Zeile 5-7)
		
//3. Schritt: State machine hochfahren

	Out.ControlWord = 0x6;				// schaltet in den Zustand "enable voltage"
	do 	{
		yield();						// warten auf den nchsten Zyklus (1ms)
		}
		while ( (od_read(0x6041, 0x00) & 0xEF) != 0x21);   // wartet bis der Zustand ist "enable voltage" 
	
	// berprft das Statusword (0x6041) auf die Bitmaske: xxxx xxxx x01x 0001
	
	Out.ControlWord = 0x7;				// schaltet in den Zustand "switched on"
	do 	{
		yield();						// warten auf den nchsten Zyklus (1ms)
		}
		while ( (od_read(0x6041, 0x00) & 0xEF) != 0x23);   // wartet bis der Zustand ist "switched on" 
	// berprft das Statusword (0x6041) auf die Bitmaske xxxx xxxx x01x 0011	
		
	Out.ControlWord = 0xF;				// schaltet in den Zustand "enable operation" und startet den velocity mode							
	do 	{
		yield();						// warten auf den nchsten Zyklus (1ms)
		}
		while ( (od_read(0x6041, 0x00) & 0xEF) != 0x27);   // wartet bis der Zustand ist "operation enabled"	
	// berprft das Statusword (0x6041) auf die Bitmaske: xxxx xxxx x01x 0111	
		
	while(true)							// Endlosschleife
	{yield();}	                      	// warten auf den nchsten Zyklus (1ms)
		
}	